//Mihai Popa
//n^2, 60p

#include<stdio.h>
#include<vector>
#include<algorithm>

#define maxdim 5005
#define mod 666013

using namespace std;

int n,k;
int special[maxdim],viz[maxdim],T[maxdim],D[maxdim][maxdim],localD[maxdim][maxdim],toate[maxdim];
vector<int>G[maxdim];

void dfs ( int nod ){
	viz[nod] = 1;
	
	int sons = 0;
	for ( vector<int>::iterator itt = G[nod].begin() ; itt != G[nod].end() ; ++itt ){
		int fiu = *itt;
		if ( viz[fiu] )	continue ;
		
		++sons; T[fiu] = nod;
		dfs(fiu);
	}
	
	if ( !sons ){
		if ( special[nod] ){
			D[nod][nod] = 1; toate[nod] = 1;
		}
		else{
			D[nod][0] = 1; toate[nod] = 1;
		}
		return ;
	}
	
	localD[0][0] = 1; int ind = 0;
	for ( vector<int>::iterator itt = G[nod].begin() ; itt != G[nod].end() ; ++itt ){
		int fiu = *itt;
		if ( T[fiu] != nod )	continue ;
		
		++ind;
		for ( int j = 1 ; j <= n ; ++j ){
			localD[ind][j] = (1LL*localD[ind-1][j]*toate[fiu] + 1LL*localD[ind-1][0]*D[fiu][j])%mod;
		}
		localD[ind][0] = (1LL*localD[ind-1][0]*toate[fiu])%mod;
	}
	
	if ( !special[nod] ){
		for ( int j = 0 ; j <= n ; ++j ){
			D[nod][j] = localD[ind][j];
			toate[nod] += D[nod][j];
			if ( toate[nod] >= mod )	toate[nod] -= mod;
		}
	}
	else{
		D[nod][nod] = localD[ind][0];
		toate[nod] = D[nod][nod];
	}
}

int main () {
	
	freopen("karb.in","r",stdin);
	freopen("karb.out","w",stdout);
	
	scanf("%d %d",&n,&k);
	int x,y;
	for ( int i = 1 ; i <= k ; ++i ){
		scanf("%d",&x);
		special[x] = 1;
	}
	for ( int i = 1 ; i < n ; ++i ){
		scanf("%d %d",&x,&y);
		G[x].push_back(y);
		G[y].push_back(x);
	}
	
	dfs(1);
	
	int sol = toate[1]-D[1][0];
	if ( sol < 0 )	sol += mod;
	printf("%d\n",sol);
	
	return 0;
}
